#ifndef _USB_DESCRIPT__H
#define _USB_DESCRIPT__H

#include <stdint.h>

/**
 * USB5ӳ
*/
#define DEVICE_DESCRIPTOR 0x01
#define CONFIGURATION_DESCRIPTOR 0x02
#define STRING_DESCRIPTOR 0x03
#define INTERFACE_DESCRIPTOR 0x04
#define ENDPOINT_DESCRIPTOR 0x05
#define CS_INTERFACE 0x24

#pragma pack(1)
// 豸
typedef struct
{
    uint8_t bLength;            //ṹС
    uint8_t bDescriptorType;    //
    uint16_t bcdUSB;            //USB汾
    uint8_t bDeviceClass;       //豸루USBٷ䣩
    uint8_t bDeviceSubClass;    //루USBٷ䣩
    uint8_t bDeviceProtocol;    //豸Э루USBٷ䣩
    uint8_t bMaxPacketSize0;    //˵0СЧСΪ8,16,32,64
    uint16_t idVendor;          //̱ţUSBٷ䣩
    uint16_t idProduct;         //Ʒţ쳧̷䣩
    uint16_t bcdDevice;         //豸
    uint8_t iManufacturer;      //豸ַ
    uint8_t iProduct;           //Ʒַ
    uint8_t iSerialNumber;      //豸кַ
    uint8_t bNumConfigurations; //ǰٶֵ֧
} Device_Descriptor_t;

// 
typedef struct
{
    uint8_t bLength;             //
    uint8_t bDescriptorType;     //
    uint16_t wTotallLength;      //ܳ
    uint8_t bNumInterfaces;      //ֵ֧Ľӿ
    uint8_t bConfigurationValue; //õֵ
    uint8_t iConfiguration;      //õֵַ
    uint8_t bmAttributes;        //ģʽѡBit4-0D7:				߹磬D6:Թ磬D5:Զ̻
    uint8_t bMaxPower;           //豸Ҫ 1LSB = 2mA
} Configuration_Descriptor_t;

// ӿ
typedef struct
{
    uint8_t bLength;            //С
    uint8_t bDescriptorType;    //ӿͣ
    uint8_t bInterfaceNumber;   //ýӿڵıţ
    uint8_t bAlternateSetting;  //Ϊһֶѡɹ滻λãõĽӿţ
    uint8_t bNumEndpoint;       //ʹõĶ˵Ŀ˵㣰⣮
    uint8_t bInterfaceClass;    //ʹ룮
    uint8_t bInterfaceSubClass; //ʹ룮
    uint8_t bInterfaceProtocol; //Э룮
    uint8_t iInterface;         //ַ
} Interface_Descriptor_t;

// ˵
typedef struct
{
    uint8_t bLength;         //С
    uint8_t bDescriptorType; //ӿͣ
    uint8_t bEndpointType;   //USB豸Ķ˵ַBit7򣬶ڿƶ˵							Ժԣ1/0:IN/OUTBit6-4BIt3-0˵ţ
    uint8_t bmAttributes;    //˵ԣBit7-2BIt1-000ƣ01ͬ0203					жϣ
    uint16_t wMaxPacketSize; //˵ջ͵ϢС
    uint8_t bInterval;       //ѯݴͶ˵ʱͺͿƴ͵Ķ˵			ͬ͵Ķ˵㣬Ϊжϴ͵Ķ˵㣬ΧΪ
} Endpoint_Descriptor_t;

// ID
typedef struct
{
    uint8_t bLength;         //С
    uint8_t bDescriptorType; //ӿ̶ͣΪ0x03
    uint16_t ID;             //Ա룮
} ID_Descriptor_t;

typedef struct
{
    uint8_t bFunctionLength;    //
    uint8_t bDescriptorType;    //CS_INTERFACE
    uint8_t bDescriptorSubtype; //0x00
    uint16_t bcdCDC;            //0x0110
} Header_Func_Desc_t;

typedef struct
{
    uint8_t bFunctionLength;    //
    uint8_t bDescriptorType;    // CS_INTERFACE
    uint8_t bDescriptorSubtype; //0x01
    uint8_t bmCapabilities;     //D0=0ʾùD0=0ʱD1ЧD2-D7
    uint8_t bDataInterface;
} Call_Management_Func_Desc_t;

typedef struct
{
    uint8_t bFunctionLength;    //
    uint8_t bDescriptorType;    //CS_INTERFACE
    uint8_t bDescriptorSubtype; //0x02
    uint8_t bmCapabilities;     //
} Abstract_Control_Management_Func_Desc_t;

#define SLAVEINTERFACE 1
typedef struct
{
    uint8_t bFunctionLength;    //
    uint8_t bDescriptorType;    //CS_INTERFACE
    uint8_t bDescriptorSubtype; //0x06
    uint8_t bMasterInterface;
    uint8_t bSlaveInterface[SLAVEINTERFACE];
} Union_Functional_Descriptor_t;

// 
typedef struct
{
    Configuration_Descriptor_t Configuration_Desc;
    Interface_Descriptor_t Communication_Interface_Desc;
    Header_Func_Desc_t Header_Func_Desc;
    Call_Management_Func_Desc_t Call_Management_Func_Desc;
    Abstract_Control_Management_Func_Desc_t Abstract_Control_Management_Func_Desc;
    Union_Functional_Descriptor_t Union_Functional_Desc;
    Endpoint_Descriptor_t Communication_Endpoint_Desc;
    Interface_Descriptor_t Data_Interface_Desc;
    Endpoint_Descriptor_t Data_Endpoint_Desc1;
    Endpoint_Descriptor_t Data_Endpoint_Desc2;
} Descriptor_Set_t;



#pragma pack()

extern Device_Descriptor_t Device_Descriptor;
extern Descriptor_Set_t Descriptor_Set;
extern ID_Descriptor_t ID_Descriptor;


void descript_init(void);

#endif
